<template>
  <div>
    <el-dialog
      :title="title"
      :close-on-click-modal="false"
	  draggable
      append-to-body
      width="1300px"
      @close="close"
      v-model="visible">
    <el-form :model="inputForm" ref="inputForm" v-loading="loading" :class="method==='view'?'readonly':''"  :disabled="status === 'audit' || status === 'taskFormDetail'"
             label-width="100px" @submit.native.prevent>

      <el-divider content-position="left"><i class="el-icon-document"></i> 基础信息</el-divider>
      <el-row :gutter="26">
        <el-col :span="12">
          <el-form-item label="领用编号" prop="collectNo">
            <el-input placeholder="自动生成" v-model="inputForm.collectNo" :disabled="true"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="经办人" prop="handledBy">
            <el-input v-model="inputForm.handledBy" :disabled="true"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="经办人部门" prop="handledByOffice">
            <SelectTree
              :disabled="true"
              ref="officeTree"
              :props="{
                  value: 'id',             // ID字段名
                  label: 'name',         // 显示名称
                  children: 'children'    // 子级字段名
                }"

              :url="`/system-server/sys/office/treeData?type=2`"
              :value="inputForm.handledByOffice"
              :accordion="true"
              size="default"
              @getValue="(value) => {inputForm.handledByOffice=value}"/>
<!--            <el-input v-model="inputForm.handledByOffice" :disabled="true"></el-input>-->
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="领用时间" prop="collectTime" :rules="[{required: true, message:'请选择领用时间', trigger:'blur'}]">
            <el-date-picker
              :disabled="true"
              v-model="inputForm.collectDate"
              type="date"
              placement="bottom-start"
              value-format="YYYY-MM-DD"
              style="width: 100%"
              placeholder="选择日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="24">
          <el-form-item label="备注" prop="remarks">
            <el-input v-model="inputForm.remarks"
                      type="textarea"
                      :rows="5"
                      maxlength="500"
                      placeholder="请填写备注信息"
                      :disabled="true"
                      show-word-limit>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-divider content-position="left"><i class="el-icon-document"></i>
        领用详情
      </el-divider>
      <el-row  :gutter="15" >
        <el-col :span="24">
			<vxe-table
				border
				show-footer
				show-overflow
				ref="detailTable"
				class="vxe-table-element"
				:data="inputForm.detailInfos"
				style="margin-left: 5em"
				:row-class-name="rowClassName"
			>
				<vxe-table-column field="recipientAgent" title="领用人" align="center">
					<template #default="scope">
						<span>{{scope.row.recipientAgent}}</span><span v-if="scope.row.isReturn === '1'">(已退回)</span>
					</template>
				</vxe-table-column>
				<vxe-table-column field="recipientOffice" title="领用人部门" align="center"></vxe-table-column>
				<vxe-table-column field="collectType" title="领用类型" align="center"></vxe-table-column>
				<vxe-table-column field="goodsName" title="物品名称" align="center"></vxe-table-column>
				<vxe-table-column field="collectNumber" title="领用数量" align="center"></vxe-table-column>
				<vxe-table-column field="surplusNumber" title="库存数量" align="center"></vxe-table-column>
				<vxe-table-column field="company" title="单位" align="center"></vxe-table-column>
				<vxe-table-column field="remarks" title="备注" align="center"></vxe-table-column>
				<vxe-table-column title="操作" width="170" align="center">
					<template #default="scope">
						<el-button type="primary" :disabled="false" @click="seeFileInfo(scope.$rowIndex)">附件</el-button>
					</template>
				</vxe-table-column>
			</vxe-table>
		</el-col>
      </el-row>
      <el-row>
        <el-col :span="24" style="margin-top: 20px">
          <el-form-item label="退回原因" prop="returnCause">
            <el-input v-model="inputForm.returnCause"
                      type="textarea"
                      :rows="5"
                      maxlength="500"
                      placeholder="请填写退回原因"
                      :disabled="true"
                      show-word-limit>
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>

    </el-form>
    <PurchasePageForm  ref="purchasePageForm" @getProject="getContract"></PurchasePageForm>
    <!-- 附件 -->
    <MaterialManagementDialog ref="materialManagementDialog" @getUpload="getUpload"></MaterialManagementDialog>
    <UpLoadComponent ref="uploadComponent"></UpLoadComponent>
    <CwProgramPageForm ref="cwProgramPageForm" @getProgram="getProgram"></CwProgramPageForm>
    <MaterialTypePullForm ref="materialTypePullForm" @getProgramForType="getProgramForType"></MaterialTypePullForm>
    <UserPullForm ref="userPullForm" @getProgramForUser="getProgramForUser"></UserPullForm>
      <template #footer>
		  <span class="dialog-footer">
			  <el-button  @click="close()" icon="el-icon-circle-close">关闭</el-button>
		  </span>
	  </template>

    </el-dialog>
  </div>
</template>

<script>
  import MaterialManagementDialog from '../file/MaterialManagementDialog'
  import CollectService from '@/api/materialManagement/CollectService'
  import UpLoadComponent from '@/views/common/UpLoadComponent'
  import SelectTree from '@/components/treeSelect/treeSelect.vue'
  import CwProgramPageForm from '@/views/cw/reimbursementApproval/info/CwProgramPageForm'
  import MaterialTypePullForm from '../info/MaterialTypePullForm'
  import UserPullForm from '@/views/finance/invoice/UserPullForm'
  import PurchasePageForm from './PurchasePageForm'
  import CommonApi from '@/api/cw/common/CommonApi'
  export default {
    data () {
      return {
        validRules: {
          recipientAgent: [
            {required: true, message: '领用人不能为空'}
          ],
          recipientOffice: [
            {required: true, message: '领用人部门不能为空'}
          ],
          collectType: [
            {required: true, message: '领用类型不能为空'}
          ],
          goodsName: [
            {required: true, message: '物品名称不能为空'}
          ],
          collectNumber: [
            {required: true, message: '领用数量不能为空'}
          ]
        },
        title: '',
        method: '',
        visible: false,
        loading: false,
        indexRow: '',
        inputForm: {
          fileInfoLost: [],
          handledByOffice: '',
          handledBy: '',
          handledById: '',
          collectNo: '', // 领用编号
          userId: '',
          collectDate: '',
          remarks: '',
          detailInfos: [],
          // amountInfos: [],
          files: [], // 附件信息
          procInsId: '',
          statusReturn: '',
          procInsIdReturn: '',
          processDefinitionIdReturn: '',
          returnId: '',
          returnCause: '',
          returnFiles: []
        },
        keyWatch: ''
      }
    },
    collectService: null,
    commonApi: null,
    created () {
      this.collectService = new CollectService()
      this.commonApi = new CommonApi()
    },
    props: {
      businessId: {
        type: String,
        default: ''
      },
      formReadOnly: {
        type: Boolean,
        default: false
      },
      status: {
        type: String,
        default: ''
      }
    },
    components: {
      MaterialManagementDialog,
      UpLoadComponent,
      SelectTree,
      CwProgramPageForm,
      MaterialTypePullForm,
      UserPullForm,
      PurchasePageForm
    },
    computed: {
      bus: {
        get () {
          return this.businessId
        },
        set (val) {
          this.businessId = val
        }
      },
      name () {
        return this.$store.state.user.name
      },
      officeName () {
        return this.$store.state.user.office.name
      },
      userId () {
        return this.$store.state.user.id
      },
      recipientAgentId () {
        return this.$store.state.user.id
      },
      collectTypeId () {
        return ''
      }
    },
    watch: {
      'keyWatch': {
        handler (newVal) {
          if (this.commonJS.isNotEmpty(this.bus)) {
            this.init('', this.bus)
          } else {
            this.$nextTick(() => {
              this.$refs.inputForm.resetFields()
            })
          }
        }
      },
      'loading': {
        handler (newVal) {
          this.$emit('changeLoading', newVal)
          this.$refs.uploadComponent.changeLoading(newVal)
        }
      }
    },
    methods: {
      getKeyWatch (keyWatch) {
        this.keyWatch = keyWatch
      },
      init (id) {
        let method = 'view'
        this.method = method
        this.inputForm = {
          fileInfoLost: [],
          handledByOffice: '',
          handledBy: this.$store.state.user.name,
          handledById: this.$store.state.user.id,
          collectNo: '', // 领用编号
          userId: this.$store.state.user.id,
          collectDate: new Date(),
          remarks: '',
          detailInfos: [],
          // amountInfos: [],
          files: [], // 附件信息
          procInsId: '',
          statusReturn: '',
          procInsIdReturn: '',
          processDefinitionIdReturn: '',
          returnId: '',
          returnCause: '',
          returnFiles: []
        }
        this.title = '领用退回历史详情'
        this.inputForm.id = id
        this.visible = true
        this.loading = false
        this.$nextTick(() => {
          if (this.commonJS.isEmpty(this.inputForm.handledByOffice)) {
            this.inputForm.handledByOffice = this.$store.state.user.office.id
          }
          if (this.status === 'audit' || this.status === 'taskFormDetail') {
            method = 'view'
          }
          this.loading = true
          this.$refs.inputForm.resetFields()
          this.collectService.findHiByHiId(this.inputForm.id).then((data) => {
            this.$refs.uploadComponent.clearUpload()
            if (this.inputForm.id !== 'false') {
              this.inputForm = this.recover(this.inputForm, data)
              this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
              if (this.commonJS.isEmpty(this.inputForm.handledByOffice)) {
                this.inputForm.handledByOffice = this.$store.state.user.office.id
              }
              if (this.commonJS.isNotEmpty(data.recipientAgentId)) {
                this.recipientAgentId = data.recipientAgentId
              }
              if (this.commonJS.isNotEmpty(data.collectTypeId)) {
                this.collectTypeId = data.collectTypeId
              }
              if (this.commonJS.isNotEmpty(this.inputForm.detailInfos)) {
                let i = this.inputForm.detailInfos.length
                for (let j = 0; j < i; j++) {
                  if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradePrice)) {
                    if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].tradeNumber)) {
                      this.inputForm.detailInfos[j].priceSum = this.inputForm.detailInfos[j].tradePrice * this.inputForm.detailInfos[j].tradeNumber
                    }
                  }
                }
              }
              if (this.commonJS.isEmpty(this.inputForm.returnFiles)) {
                this.inputForm.returnFiles = []
              }
              this.$refs.uploadComponent.newUpload('view', this.inputForm.returnFiles, 'collect_return')
              this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
              this.loading = false
            } else {
              if (this.commonJS.isEmpty(this.inputForm.handledByOffice)) {
                this.inputForm.handledByOffice = this.$store.state.user.office.id
              }
              if (this.commonJS.isEmpty(this.inputForm.handledBy)) {
                this.inputForm.handledBy = this.$store.state.user.name
              }
              if (this.commonJS.isEmpty(this.inputForm.handledById)) {
                this.inputForm.handledById = this.$store.state.user.id
              }
              if (this.commonJS.isEmpty(this.inputForm.collectDate)) {
                this.inputForm.collectDate = new Date()
              }
              this.inputForm.detailInfos = []
              this.loading = false
            }
          })
        })
      },
      getUpload (p, index) {
        p.then((list) => {
          // list为返回数据
          this.inputForm.detailInfos[index].fileInfoLost = list
          this.inputForm.detailInfos[index].fileNumber = list.length
          this.tableKeyClient = Math.random()
        })
      },
      seeFileInfo (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload('view', this.inputForm.detailInfos[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      sss (index) {
        if (this.commonJS.isEmpty(this.inputForm.detailInfos[index].fileInfoLost)) {
          this.inputForm.detailInfos[index].fileInfoLost = []
        }
        this.$refs.materialManagementDialog.newUpload(null, this.inputForm.detailInfos[index].fileInfoLost, null, null, null, null, null, false, index)
      },
      // 表单提交
      doSubmit () {
        this.$refs['inputForm'].validate((valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            this.inputForm.id = this.businessId
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.collectService.save(this.inputForm).then((data) => {
              this.close()
              this.$message.success(data)
              this.$emit('refreshDataList')
              this.loading = false
            }).catch(() => {
              this.loading = false
            })
          }
        })
      },
      close () {
        this.inputForm.detailInfos = []
        // this.inputForm.amountInfos = []
        this.$refs.uploadComponent.clearUpload()

        this.visible = false
        this.$refs.inputForm.resetFields()
      },
      // 删除
      removeEvent (row, rowIndex, type) {
        if (type === 'detail') {
          this.$refs.detailTable.remove(row)
          this.inputForm.detailInfos.splice(rowIndex, 1)
        }
        if (type === 'amount') {
          this.$refs.amountTable.remove(row)
          // this.inputForm.amountInfos.splice(rowIndex, 1)
        }
      },
      // 新增
      async insertEvent (type) {
        if (type === 'detail') {
          await this.$refs.detailTable.insert().then((data) => {
            data.recipientAgent = this.$store.state.user.name
            data.recipientAgentId = this.recipientAgentId
            data.recipientOffice = this.officeName
            this.inputForm.detailInfos.push(data)
          })
        }
        if (type === 'amount') {
          await this.$refs.amountTable.insert().then((data) => {
            // this.inputForm.amountInfos.push(data)
          })
        }
      },
      reapplyForm (callback) {
        this.loading = true
        this.collectService.findById(this.inputForm.id).then((data) => {
          if (data.statusReturn !== '4') { // 审核状态不是“驳回”，就弹出提示
            this.loading = false
            this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
            throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
          } else {
            this.startFormTrue(callback)
          }
        })
      },
      startForm (callback) {
        this.loading = true
        if (this.commonJS.isNotEmpty(this.inputForm.id)) {
          this.collectService.findById(this.inputForm.id).then((data) => {
            // 审核状态不是“未发起”或“暂存”或“撤回”，就弹出提示
            if (this.commonJS.isNotEmpty(data.statusReturn) && data.statusReturn !== '0' && data.statusReturn !== '1' && data.statusReturn !== '3') {
              this.loading = false
              this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
              throw new Error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
            } else {
              this.startFormTrue(callback)
            }
          })
        } else {
          this.startFormTrue(callback)
        }
      },
      // 暂存
      async saveForm (callback) {
        this.loading = true
        if (this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          return
        }
        if (this.commonJS.isEmpty(this.inputForm.files)) {
          this.inputForm.files = []
        }
        this.inputForm.files = this.$refs.uploadComponent.getDataList()
        this.inputForm.statusReturn = '1'
        this.collectService.saveReturn(this.inputForm).then((data) => {
          callback()
          this.$refs.inputForm.resetFields()
          this.loading = false
        }).catch(() => {
          this.$refs.inputForm.resetFields()
          this.loading = false
        })
      },
      // 送审
      async startFormTrue (callback) {
        this.loading = true
        this.$refs['inputForm'].validate(async (valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            if (this.commonJS.isEmpty(this.inputForm.detailInfos)) {
              this.$message.error('至少填写一条领用详情信息')
              this.loading = false
              return
            } else {
              let i = this.inputForm.detailInfos.length
              for (let j = 0; j < i; j++) {
                let k = j + 1
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].recipientAgent)) {
                  this.$message.error('领用详情第' + k + '行请选择领用人')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].collectType)) {
                  this.$message.error('领用详情第' + k + '行请选择领用类型')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].goodsName)) {
                  this.$message.error('领用详情第' + k + '行请选择物品名称')
                  this.loading = false
                  return
                }
                if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].collectNumber)) {
                  this.$message.error('领用详情第' + k + '行请输入领用数量')
                  this.loading = false
                  return
                }
              }
            }
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            this.inputForm.statusReturn = '2'
            this.collectService.saveReturn(this.inputForm).then((data) => {
              this.inputForm.id = data.businessId
              callback(data.businessTable, data.businessId, this.inputForm)
              this.$refs.inputForm.resetFields()
              this.loading = false
            }).catch(() => {
              this.$refs.inputForm.resetFields()
              this.loading = false
            })
          } else {
            this.loading = false
          }
        })
      },
      // 通过
      async agreeForm (callback) {
        this.loading = true
        this.$refs['inputForm'].validate(async (valid) => {
          if (valid) {
            this.loading = true
            if (this.$refs.uploadComponent.checkProgress()) {
              this.loading = false
              return
            }
            if (this.commonJS.isEmpty(this.inputForm.files)) {
              this.inputForm.files = []
            }
            this.inputForm.files = this.$refs.uploadComponent.getDataList()
            // this.commonApi.getTaskNameByProcInsId(this.inputForm.procInsId).then((data) => {
            //   if (this.commonJS.isNotEmpty(data)) {
            //     if (data === '仓库管理员审核') {
            //       this.inputForm.status = '5'
            //     }
            //   }
            //   this.collectService.save(this.inputForm).then((data) => {
            //     callback(data.businessTable, data.businessId, this.inputForm)
            //     this.loading = false
            //   }).catch(() => {
            //     this.loading = false
            //   })
            // })
            this.inputForm.statusReturn = '5'
            this.collectService.saveReturnAgree(this.inputForm).then((data) => {
              callback(data.businessTable, data.businessId, this.inputForm)
              this.loading = false
            }).catch(() => {
              this.loading = false
            })
          } else {
            this.loading = false
          }
        })
      },
      // 修改状态
      async updateStatusById (type, callback) {
        this.loading = true
        if (await this.$refs.uploadComponent.checkProgress()) {
          this.loading = false
          throw new Error()
        } else {
          if (type === 'reject' || type === 'reback') {
            this.collectService.findById(this.inputForm.id).then((data) => {
              if (data.statusReturn !== '2') { // status的值不等于“审核中”，就弹出提示
                this.loading = false
                this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
                throw new Error()
              } else {
                if (type === 'reject') {
                  // 驳回
                  this.inputForm.statusReturn = '4'
                }
                if (type === 'reback') {
                  // 撤回
                  this.inputForm.statusReturn = '3'
                }
                if (type === 'reject' || type === 'reback') {
                  let param = {status: this.inputForm.statusReturn, id: this.inputForm.id}
                  this.collectService.updateStatusByIdReturn(param).then(() => {
                    this.loading = false
                    callback()
                  })
                }
              }
            })
          } else if (type === 'hold') {
            this.collectService.findById(this.inputForm.id).then((data) => {
              if (data.statusReturn !== '4') { // status的值不等于“驳回”就弹出提示
                this.loading = false
                this.$message.error('任务数据已发生改变或不存在，请在待办任务中确认此任务是否存在')
                throw new Error()
              } else {
                // 终止
                this.collectService.returnRequest({id: this.inputForm.id}).then((data) => {
                  this.loading = false
                  callback()
                })
                // 终止
                // let param = {status: '0', id: this.inputForm.id}
                // this.collectService.updateStatusByIdReturn(param).then(() => {
                //   this.loading = false
                //   callback()
                // })
              }
            })
          }
        }
      },
      // updateStatusById (type) {
      //   if (type === 'reject') {
      //     this.inputForm.status = '4'
      //     this.collectService.updateStatusById(this.inputForm)
      //   }
      // },
      // footerMethod ({ columns, data }) {
      //   const footerData = [
      //     columns.map((column, columnIndex) => {
      //       if (columnIndex === 0) {
      //         return '商品总价'
      //       }
      //       if (['priceSum'].includes(column.property)) {
      //         // eslint-disable-next-line no-undef
      //         this.inputForm.tradeTotalPrice = XEUtils.sum(data, column.property)
      //         return XEUtils.sum(data, column.property)
      //       }
      //       return null
      //     })
      //   ]
      //   return footerData
      // },
      // twoDecimalPlaces (num, index) {
      //   let str = num.toString()
      //   var len1 = str.substr(0, 1)
      //   var len2 = str.substr(1, 1)
      //   // eslint-disable-next-line eqeqeq
      //   if (str.length > 1 && len1 == 0 && len2 != '.') {
      //     str = str.substr(1, 1)
      //   }
      //   // eslint-disable-next-line eqeqeq
      //   if (len1 == '.') {
      //     str = ''
      //   }
      //   // eslint-disable-next-line eqeqeq
      //   if (str.indexOf('.') != -1) {
      //     var str_ = str.substr(str.indexOf('.') + 1)
      //     // eslint-disable-next-line eqeqeq
      //     if (str_.indexOf('.') != -1) {
      //       str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
      //     }
      //     if (str_.length > 2) {
      //       this.$message.warning(`金额小数点后只能输入两位，请正确输入！`)
      //       return (str = '')
      //     }
      //   }
      //   // eslint-disable-next-line no-useless-escape
      //   this.inputForm.detailInfos[index].priceSum = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
      // },
      twoDecimalPlaces2 (num) {
        let str = num.toString()
        var len1 = str.substr(0, 1)
        var len2 = str.substr(1, 1)
        // eslint-disable-next-line eqeqeq
        if (str.length > 1 && len1 == 0 && len2 != '.') {
          str = str.substr(1, 1)
        }
        // eslint-disable-next-line eqeqeq
        if (len1 == '.') {
          str = ''
        }
        // eslint-disable-next-line eqeqeq
        if (str.indexOf('.') != -1) {
          var str_ = str.substr(str.indexOf('.') + 1)
          // eslint-disable-next-line eqeqeq
          if (str_.indexOf('.') != -1) {
            str = str.substr(0, str.indexOf('.') + str_.indexOf('.') + 1)
          }
          if (str_.length > 2) {
            this.$message.warning(`领用数量小数点后只能输入两位，请正确输入！`)
            return (str = '')
          }
        }
        // eslint-disable-next-line no-useless-escape
        str = str.replace(/[^\d^\.]+/g, '') // 保留数字和小数点
        return str
      },
      countAmount (row) {
        let amount
        let taxAmount
        let count = 0
        if (!this.commonJS.isEmpty(row.amount)) {
          amount = parseFloat(row.amount)
          count = count + amount
        }
        if (!this.commonJS.isEmpty(row.taxAmount)) {
          taxAmount = parseFloat(row.taxAmount)
          count = count + taxAmount
        }
        row.count = parseFloat(count).toFixed(2)
      },
      getProgram (rows) {
        this.inputForm.detailInfos[this.indexRow].projectId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].projectName = rows[0].name
        this.inputForm.detailInfos[this.indexRow].reportNumber = rows[0].reportNo
        this.indexRow = ''
        this.$forceUpdate()
      },
      // 领用类型下拉弹窗
      typePullForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.materialTypePullForm.init()
      },
      getProgramForType (rows) {
        this.inputForm.detailInfos[this.indexRow].collectTypeId = rows.id
        this.inputForm.detailInfos[this.indexRow].collectType = rows.name
        this.inputForm.detailInfos[this.indexRow].goodsName = ''
        this.indexRow = ''
        this.$forceUpdate()
      },
      // 领用人下拉弹窗
      userPullListForm (rowIndex) {
        this.indexRow = rowIndex
        this.$refs.userPullForm.init()
      },
      getProgramForUser (rows) {
        this.inputForm.detailInfos[this.indexRow].recipientAgentId = rows[0].id
        this.inputForm.detailInfos[this.indexRow].recipientAgent = rows[0].name
        this.inputForm.detailInfos[this.indexRow].deptId = rows[0].parentId
        this.inputForm.detailInfos[this.indexRow].recipientOffice = rows[0].officeName
        this.indexRow = ''
        this.$forceUpdate()
      },
      getUserInfo (rows) {
      },
      openPurchasePageForm (rowIndex, row) {
        if (this.commonJS.isEmpty(row.collectType)) {
          this.$message.error('请选择领用类型')
          return
        }
        this.indexRow = rowIndex
        this.$refs.purchasePageForm.init(row.collectTypeId)
      },
      getContract (row) {
        this.inputForm.detailInfos[this.indexRow].surplusNumber = row.tradeNumber
        this.inputForm.detailInfos[this.indexRow].goodsName = row.tradeName
        // 去除重复的领用详情
        let i = this.inputForm.detailInfos.length
        for (let j = 0; j < i; j++) {
          console.log('进来了')
          for (let k = j + 1; k < i; k++) {
            if (this.inputForm.detailInfos[j].collectTypeId === this.inputForm.detailInfos[k].collectTypeId) {
              if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].goodsName) &&
                this.commonJS.isNotEmpty(this.inputForm.detailInfos[k].goodsName) && this.inputForm.detailInfos[j].goodsName === this.inputForm.detailInfos[k].goodsName) {
                // parseFloat(item.account).toFixed(2)
                this.inputForm.detailInfos.splice(k, 1)
                this.$message.warning(`同种领用类型的商品名称只能输入一条信息！`)
              }
            }
          }
        }
        this.indexRow = ''
        this.$forceUpdate()
      },
      // 值改变事件
      changeValue () {
        let i = this.inputForm.detailInfos.length
        for (let j = 0; j < i; j++) {
          if (this.commonJS.isEmpty(this.inputForm.detailInfos[j].surplusNumber)) {
            this.$message.error('请选择领用物品名称')
            return
          }
          if (this.commonJS.isNotEmpty(this.inputForm.detailInfos[j].collectNumber)) {
            if (parseFloat(this.inputForm.detailInfos[j].surplusNumber) < parseFloat(this.inputForm.detailInfos[j].collectNumber)) {
              this.$message.error('领用数量不能大于剩余数量')
              this.inputForm.detailInfos[j].collectNumber = ''
              return
            }
          }
        }
      },
      // 退回
      returnCollect (index) {
        this.inputForm.detailInfos[index].isReturn = '1'
      },
      // 取消退回
      cancelReturn (index) {
        this.inputForm.detailInfos[index].isReturn = '0'
      },
      // 列表行颜色
      rowClassName ({ row, rowIndex }) {
        if (row.isReturn === '1') { // 退回
          return 'row-grey'
        } else {
          return ''
        }
      }
    }
  }
</script>
<style scoped>
  .el-divider__text {
    font-size: 16px;
    font-weight: bold;
  }
  /deep/  .row-green {
    /*background-color: #67c23ad1;*/
    /*color: #fff;*/
    font-weight: bold;
  }
  /deep/  .row-grey {
    background-color: #b8b7b7;
    color: #fff;
  }
  /deep/  .row-red {
    background-color: #f56c6c66;
    /*color: #fff;*/
    font-weight: bold;
  }
</style>
